package com.baichuanxin.openrestapi.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.util.Date;

/**
 *@Author duxiangyun
 *@Description  法人变更
 *@Date 2024/8/27
 */
@Data
@TableName("tlk_legalchangek")
public class ChangeLegalPerson {

    //表单需求数据
    @TableId("ID")
    private String id;
    //创建时间
    @TableField("CREATED")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone="GMT+8")
    private Date created;
    @TableField("LASTMODIFIED")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone="GMT+8")
    private Date lastmodified;
    @TableField("FORMNAME")
    private String formname ;
    @TableField("FORMID")
    private String formid;
    @TableField("ISTMP")
    private boolean istmp;
    @TableField("APPLICATIONID")
    private String applicationid;
    @TableField("DOMAINID")
    private String domainid;
    @TableField("ITEM_REGION")
    private String itemRegion;


    //办件数据
    @TableField("taskId")
    private String taskId;

    /**
     * 办事区域
     */
    //所属监管机构
    @TableField(value ="item_officePoliceAddress")
    private String itemOfficePoliceAddress;
    @TableField("ITEM_OFFICEPOLICEADDRESSID")
    private String itemitemOfficePoliceAddressid;
    @TableField("ITEM_OFFICEPOLICEIDINDEX")
    private String itemOfficePoliceidindex;

    //申请单位名称
    @TableField(value ="item_companyName")
    private String itemCompanyName;
    //办公住所
    @TableField(value ="item_address")
    private String  itemAddress;
    //注册资本
    @TableField(value ="item_registeredCapital")
    private String itemRegisteredCapital;
    //统一社会信用代码
    @TableField("item_uscc")
    private String itemUscc;
    //保安服务许可证号
    @TableField("item_securityTrainPermitNo")
    private String itemSecurityTrainPermitNo;
    //服务范围
    @TableField("ITEM_BUSINESSSCOPE")
    private String itemBusinessScope;
    //批准文号
    @TableField("item_approvalNumber")
    private String itemApprovalNumber;
    /**
     * 填写原股东信息  股东信息另存一张表 ShareHolder  表tlk_companypermitshareholder
     */

    /**
     * 原法定代表人信息
     */
    //姓名
    @TableField(value ="item_legalName")
    private String itemLegalName;
    //性别
    @TableField(value ="item_legalSex")
    private String  itemLegalSex;
    //民族
    @TableField(value ="item_nation")
    private String itemNation;
    //政治面貌
    @TableField(value ="item_identity")
    private String itemIdentity;
    //文化程度
    @TableField(value ="item_education")
    private String itemEducation;
    //保安师资格证编号
    @TableField(value ="item_vocational_certificate")
    private String  itemVocationalCertificate;
    //证件类型
    @TableField(value ="item_legalType")
    private String itemLegalType;
    //证件号码
    @TableField(value ="item_legalCardnumber")
    private String itemLegalCardnumber;
    //联系电话
    @TableField(value ="item_legalPhone")
    private String itemLegalPhone;

    /**
     * 拟定代表人信息
     */
    //姓名
    @TableField(value ="item_appointmentLegalName")
    private String itemAppointmentLegalName;
    //联系电话
    @TableField(value ="item_new_hunan_telephone")
    private String itemNewHunanTelephone;
    //身份证件号码
    @TableField(value ="item_new_hunan_legal")
    private String itemNewHunanLegal;

    /**
     * 许可证领取方式
     */
    //新证领取方式
    @TableField(value ="item_claim_way")
    private String itemClaimWay;
    //领取地址
    @TableField("ITEM_recipient_address")
    private String itemRecipientAddress;
    //收件人
    @TableField("ITEM_RECIPIENT")
    private String itemRecipient;
    //手机号
    @TableField("ITEM_RECIPIENT_PHONE")
    private String itemRecipientPhone;
    //收件地址


    //旧证收回方式
    @TableField(value ="item_jiu_claim")
    private String itemJiuClaim;
    //收件人
    @TableField("ITEM_CONSIGNEE")
    private String itemConsignee;
    //手机号
    @TableField("ITEM_CONSIGNEE_PHONE")
    private String itemConsigneePhone;
    //收件地址
    @TableField("ITEM_CONSIGNEE_ADDRESS")
    private String itemConsigneeAddress;
    /**
     * 经办人信息
     */
    //姓名
    @TableField("ITEM_HUNAN_NAME")
    private String itemHunanName;
    //联系电话
    @TableField("ITEM_HUNAN_OFFICE_TELEPHONE")
    private String itemHunanOfficeTelephone;


    /**
     * 承诺上述填报信息真实有效
     */
    @TableField("ITEM_PERMIT")
    private String itemPermit;
    /**
     * 上传电子版材料
     */
    //电子材料


    /**
     *@Author duxiangyun
     *@Description   审核状态数据
     *@Date 2024/8/26
     */
    //审核状态
    @TableField("ITEM_AUDITSTATUS")
    private String itemAuditStatus;
    //受理情况文件---许可情况
    @TableField("item_acceptance_file")
    private String itemAcceptanceFile;
    //许可情况
    @TableField("item_notice_file")
    private String itemNoticeFile;
    //保安服务许可证
    @TableField("item_service_file")
    private String itemServiceFile;
    //公安下发办结告知书
    @TableField("item_public_completion_file")
    private String itemPublicCompletionFile;
    //公安下发回传行政许可文书送达回证
    @TableField("item_public_reach_file")
    private String itemPublicReachFile;


    //审核时间
    @TableField("item_over_time")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone="GMT+8")
    private Date itemOverTime;
    //审核意见
    @TableField("item_apply_remark")
    private String  itemApplyRemark;
    //审核文书
    @TableField("isdelivery")
    private String isdelivery;

}
